<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TextTemplateBinding xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/transformation/core/templates/TextTemplateBinding.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * </em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> *    CEA LIST - initial API and implementation</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.transformation.core.templates;
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">import</strong> java.lang.reflect.InvocationTargetException;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> java.lang.reflect.Method;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.TransformationException;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.Messages;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.extensions.ITextTemplate;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.extensions.TextTemplateExt;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <em class="jxr_javadoccomment"> * Support for binding/instantiation of text templates</em>
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/templates/TextTemplateBinding.html">TextTemplateBinding</a> {
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String TEMPLATE_MAGIC = <span class="jxr_string">"!template"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <em class="jxr_javadoccomment">	 * Simple template expression that is replaced with the name of a named</em>
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <em class="jxr_javadoccomment">	 * element. Uses an Acceleo syntax</em>
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <em class="jxr_javadoccomment">	 * The objective is that the access to an element name is very common and does</em>
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <em class="jxr_javadoccomment">	 * not need an xtend script behind.</em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String NAME_IN_BRACKETS = <span class="jxr_string">"[name/]"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <em class="jxr_javadoccomment">	 * Simple template expression that is replaced with the name of a named</em>
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <em class="jxr_javadoccomment">	 * element. Slight variation of the Acceleo syntax</em>
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String NAME_IN_BRACKETS_SIMPLE = <span class="jxr_string">"[name]"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <em class="jxr_javadoccomment">	 * Execute a script passed as parameter. It will be executed in the context</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <em class="jxr_javadoccomment">	 * of a base script that declares the meta-model (UML2) and has additional</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <em class="jxr_javadoccomment">	 * imports (currently none).</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <em class="jxr_javadoccomment">	 * @param template</em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <em class="jxr_javadoccomment">	 *            The template in string form</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment">	 * @param element</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <em class="jxr_javadoccomment">	 *            The UML element to which the template is applied</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment">	 * @return the evaluated template</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String bind(String templateStr, Element element) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  		<strong class="jxr_keyword">return</strong> bind(templateStr, element, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  	}
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  <em class="jxr_javadoccomment">	 * Execute a script passed as parameter. It will be executed in the context</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <em class="jxr_javadoccomment">	 * of a base script that declares the meta-model (UML2). It allows for</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  <em class="jxr_javadoccomment">	 * additional arguments</em>
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  <em class="jxr_javadoccomment">	 * @param template</em>
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  <em class="jxr_javadoccomment">	 *            The template in string form</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  <em class="jxr_javadoccomment">	 * @param element</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  <em class="jxr_javadoccomment">	 *            The UML element to which the template is applied</em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  <em class="jxr_javadoccomment">	 * @return the evaluated template</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String bind(String templateStr, Element element, Object args[]) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  		<strong class="jxr_keyword">if</strong> (templateStr.startsWith(TEMPLATE_MAGIC)) {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  			<strong class="jxr_keyword">return</strong> bindTemplate(templateStr, element, args);
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  		}
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (element instanceof NamedElement) {
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  			<em class="jxr_comment">// simple replacement of specific template entry [name]</em>
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  			String name = ((NamedElement) element).getName();
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  			<strong class="jxr_keyword">if</strong> (templateStr.contains(NAME_IN_BRACKETS)) {
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  				<strong class="jxr_keyword">return</strong> templateStr.replace(NAME_IN_BRACKETS, name);
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  			}
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  			<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (templateStr.contains(NAME_IN_BRACKETS_SIMPLE)) {
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  				<strong class="jxr_keyword">return</strong> templateStr.replace(NAME_IN_BRACKETS_SIMPLE, name);
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  			}
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  		}
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  		<strong class="jxr_keyword">return</strong> templateStr;
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  	}
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  <em class="jxr_javadoccomment">	 * Execute a script passed as parameter. It will be executed in the context</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  <em class="jxr_javadoccomment">	 * of a base script that declares the meta-model (UML2) and has additional</em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  <em class="jxr_javadoccomment">	 * imports (currently none).</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  <em class="jxr_javadoccomment">	 * @param template</em>
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  <em class="jxr_javadoccomment">	 *            The template in string form</em>
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  <em class="jxr_javadoccomment">	 * @param element</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  <em class="jxr_javadoccomment">	 *            The UML element to which the template is applied</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  <em class="jxr_javadoccomment">	 * @return the evaluated template</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String bindTemplate(String templateStr, Element element, Object args[]) <strong class="jxr_keyword">throws</strong> TransformationException {
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  		String[] templateRef = templateStr.substring(TEMPLATE_MAGIC.length() + 1).split(<span class="jxr_string">"&#92;&#92;."</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 		String templateId = templateRef[0].trim();
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 		String methodName = templateRef[1].trim();
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 		ITextTemplate generator = TextTemplateExt.getTextTemplate(templateId);
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 		<strong class="jxr_keyword">if</strong> (generator == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/base/utils/TransformationException.html">TransformationException</a>(String.format(Messages.TextTemplateBinding_TemplateNotFound, templateId, methodName));
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		}
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 		
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 			Object result;
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 			<strong class="jxr_keyword">if</strong> (args != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 				Method method = getMethod(generator, methodName, 1+args.length);
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 				result = method.invoke(generator, element, args);
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 			}
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 			<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 				Method method = getMethod(generator, methodName, 1);
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 				result = method.invoke(generator, element);
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 			}
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 			<strong class="jxr_keyword">if</strong> (result instanceof String) {
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 				<strong class="jxr_keyword">return</strong> (String) result;
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 			}
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 			<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (result instanceof CharSequence) {
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 				<strong class="jxr_keyword">return</strong> result.toString();
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 			}
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 			<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 				<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/base/utils/TransformationException.html">TransformationException</a>(Messages.TextTemplateBinding_TemplateResultIsNotAString);
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 			}
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 		} <strong class="jxr_keyword">catch</strong> (SecurityException | IllegalAccessException
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 				| IllegalArgumentException | InvocationTargetException | NullPointerException e) {
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 			<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> RuntimeException(e);
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 		}
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 	}
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Method getMethod(<a href="../../../../../../../org/eclipse/papyrus/designer/transformation/extensions/ITextTemplate.html">ITextTemplate</a> generator, String methodName, <strong class="jxr_keyword">int</strong> numberOfArguments) {
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 		<strong class="jxr_keyword">for</strong> (Method method : generator.getClass().getMethods()) {
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 			<strong class="jxr_keyword">if</strong> (method.getName().equals(methodName) &amp;&amp; method.getParameterTypes().length == numberOfArguments) {
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 				<strong class="jxr_keyword">return</strong> method;
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 			}
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 		}
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 	}
<a class="jxr_linenumber" name="L140" href="#L140">140</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
